<html>
<head>
<title>Gump.java</title>
</head>
<body>
<p>
<pre>
/*
 *	Gump 0.2b
 *	by Mathew A. Hennessy
 *	(24 Jan 1997)
 *
 *	(my second applet)
 *	
 *	What is this program?
 *	This program allows you to enter Perl code into a text-editing
 *	region, provide a URL containing a Perl interpreter, and then
 *	run the code you've entered on the remote system.  Clearly, this
 * 	is a gaping security hole large enough to pilot a B-52 through,
 *	which is why in an ideal world there would be _no_ URLs pointing
 *	to Perl interpreters.  The fact that there _are_ URLs pointing to
 * 	Perl interpreters reveals the ignorance or foolishness of Webmasters
 *	responsible for those servers.  Thus, the name of this applet:
 *	"Stupid is as stupid does!"
 *
 *	Why did I write it?
 *	several reasons:
 *	o to see if I could do it
 *	o to learn more about the GUI-building and URL-networking aspects of Java
 *	o to provide an impetus for enhancing security on the internet
 *	o partly, as a sneaky, underhanded ploy _against_ Windows NT (I'm a Unix bigot)
 *	o mostly, because I'm bored silly.
 *
 *	Why am I giving it away?
 *	o spirit of the internet
 *	o vanity
 *	o a genuine desire to see security improved
 * 	o again, as a sneaky, underhanded ploy against Microsoft! ;)
 *	o mostly, to get criticism and eyeballs checking my code, so I'll become
 * 	  a better coder.
 *
 *	What else needs to be done?
 *	A lot, including:
 *	o better error handling
 *	o better CGI results handling
 *
 *	LEGAL SCHTUFF
 *	Permission to build and run this code is given for
 *	non-criminal use.  Permission to copy or derive
 *	from this code is given, with the restriction that
 *	any modifications are clearly labeled and that any code
 *	derived list the following as a contributor:
 *	Mathew A. Hennessy (hennessy@thoughtcrime.com)
 *
 *	No charge is required, for either non-commercial or commercial use
 *	of the code.  However, an email message is appreciated, as well
 *	as a good pint o'Guinness.
 *
 *	This code is provided AS-IS, with no warranty implied or
 *	offered.  Use at your own risk.  Your mileage may vary.  News at 11.
 *
 */
import java.net.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import java.applet.*;

public class Gump extends Applet implements Runnable
{

//
// Variables: declared
//

	Thread 		gumpThread;
	GumpSubmit	gumpSubmitProc;

	Button 		gumpSubmit;
	TextArea 	gumpCodeArea;
	TextField 	gumpURLField;
	String		gumpCode, gumpURLString;

//
// Variables: declared and defined
//

	int gumpCodeRows=6;
	int gumpCodeCols=30;
	int gumpURLCols =30;

//
// version info

	String progName="Gump";
	String version ="0.2b (Java; I)";

//
// Methods: (Applet) start() stop() init() 
//

	public void start()
	{
		if (gumpThread == null)
		{
			gumpThread=new Thread(this);
			gumpThread.start();
		} else
		{
			this.removeAll();
		}
	}// end of start()

	public void stop()
	{
		if (gumpThread != null)
		{
			this.removeAll();
			gumpThread=null;
		}
	}// end of stop()

	public void init()
	{
		// nothing to initialize yet..
	}// end of init()

	public boolean action(Event e, Object arg)
	{
		Object target=e.target;

		gumpURLString=gumpURLField.getText();
		gumpCode=gumpCodeArea.getText();

		if (target == gumpSubmit)
		{
			gumpSubmitProc=new GumpSubmit(gumpURLString,gumpCode,this);
			gumpSubmitProc.start();
		}

		return true;
	}// end of action()

//
// Methods: (Runnable) run()
//

	public void run()
	{
		// nothing really to run, either..
		drawGumpForm();
	}//end of run()

//
// Methods: (custom)
//

	public void drawGumpForm()
	{

		// define these components like so:
		// Panel gumpURLPanel, gumpCodeAreaPanel, gumpTextPanel, gumpButtonPanel, gumpAllPanel

		Panel gumpURLPanel=new Panel();
		Panel gumpCodeAreaPanel=new Panel();
		Panel gumpTextPanel=new Panel();
		Panel gumpButtonPanel=new Panel();
		Panel gumpAllPanel=new Panel();

		Label gumpURLFieldLabel=new Label("URL");
                gumpURLField=new TextField(gumpURLCols);

                Label gumpCodeAreaLabel=new Label("Perl code");
		gumpCodeArea=new TextArea(gumpCodeRows,gumpCodeCols);
		gumpCodeArea.setEditable(true);

		gumpSubmit=new Button("Gump!");

		// build the form
		// put URLPanel together first, then CodeAreaPanel, then TextPanel, then AllPanel

		gumpURLPanel.setLayout(new BorderLayout());
		gumpURLPanel.add("North",gumpURLFieldLabel);
		gumpURLPanel.add("South",gumpURLField);

		gumpCodeAreaPanel.setLayout(new BorderLayout());
		gumpCodeAreaPanel.add("North",gumpCodeAreaLabel);
		gumpCodeAreaPanel.add("South",gumpCodeArea);

		gumpButtonPanel.setLayout(new FlowLayout());
		gumpButtonPanel.add(gumpSubmit);

		gumpTextPanel.setLayout(new BorderLayout());
		gumpTextPanel.add("North", gumpURLPanel);
		gumpTextPanel.add("South", gumpCodeAreaPanel);

		gumpAllPanel.setLayout(new BorderLayout());
		gumpAllPanel.add("South", gumpTextPanel);
		gumpAllPanel.add("North", gumpButtonPanel);

		this.setLayout(new FlowLayout());
		this.add(gumpAllPanel);

		// validate it
		this.validate();

	}//end of drawGumpForm

}// end of Gump Class

// beginning GumpSubmit
//
// this code should be relatively easy to hack into a generic,
// POST-compatible CGI submitter.
//
class GumpSubmit implements Runnable
{
	URL gumpURL;
	String gumpURLString,gumpCode,gumpCodePOST;
	Thread gumpSubmitThread;
	Gump gump;

	boolean badURL=false;

	public GumpSubmit(String gus, String gcode, Gump x) 
	{
		gumpURLString = gus;
		gumpCode = gcode;
		gump=x;
	}

	public void start()
	{
		if (gumpSubmitThread == null)
		{
			gumpSubmitThread = new Thread(this);
		}
		this.run();
	}

	public void stop()
	{
		if (gumpSubmitThread != null)
		{
			gumpSubmitThread = null;
		}
	}

	public void run()
	{
		//System.out.println("Gump URL:" + gumpURLString);
		gump.showStatus("Gump URL:" + gumpURLString);

		// here we're going to do the net "thing"..


		// step 1: get the URL into a URL object
		try
		{
			gumpURL=new URL(gumpURLString);
		} catch (MalformedURLException mue)
		{
			gump.showStatus("URL " + gumpURLString + " invalid!");
			badURL=true;
		}

		// step 2: convert code to POST formatted string
		if (gumpCode != null)
		{
			gumpCodePOST=gumpCode;
		} else
		{
			gumpCodePOST=" ";
			if (!badURL)
			{
				gump.showStatus("null code is BAD!!");
			}
		}

		if (!badURL)
		{
			this.hokeyPokey();
		}
	}//run

	public void hokeyPokey()
	{
		// step 3: connect to the URL and do the data hokey-pokey..
		try
		{
			// puke
			URLConnection gumpConnection=gumpURL.openConnection();
			gumpConnection.setRequestProperty("User-Agent:",gump.progName + "/" + gump.version);
			PrintStream gumpOut=new PrintStream(gumpConnection.getOutputStream());
			gumpOut.println(gumpCodePOST);
			// 9 Jul 1997: perhaps this will do it?
			gumpOut.flush();
			gumpOut.close();

			// suck
			DataInputStream gumpIn=new DataInputStream(gumpConnection.getInputStream());
			String newline;

			// header the output
			System.out.println("==========================\n" +
					   "Output from remote script:\n" +
					   "==========================");

			while((newline=gumpIn.readLine()) != null)
			{
				System.out.println(newline);
			}
			gumpIn.close();
		} catch (IOException ioe)
		{
			gump.showStatus("I/O Error!!");
		}
		

		gump.showStatus("Done.");
	}//hokeypokey

}// end of GumpSubmit class

/* 
 * end
 *
</pre>
<img src="http://www.users.cloud9.net/~hennessy/cgi-bin/logger?Gump.java.html"
     alt="Logger">
<pre>
 *
 */
</pre>
</html>
